package test;

import static org.junit.Assert.*;

import java.io.IOException;
import java.util.Properties;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.junit.Test;

public class JMSReplyToTest {
    private static final String QPID_CONNECTION_FACTORY = "QpidConnectionFactory";
    private static final String QPID_JNDI_PROPERTIES = "qpid.jndi.properties";

    @Test
    public void testJMSReplyTo() throws JMSException, NamingException, IOException{
        Properties properties = new Properties();
        properties.load(this.getClass().getResourceAsStream(QPID_JNDI_PROPERTIES));

        Context ctx = new InitialContext(properties);

        ConnectionFactory factory = (ConnectionFactory) ctx.lookup(QPID_CONNECTION_FACTORY);
        final Connection connection = factory.createConnection();
        try {
            connection.start();
            final Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
            Message msg = session.createTextMessage("test");
            msg.setJMSReplyTo(null);

            Queue testQueue = session.createQueue("test");
            MessageProducer producer = session.createProducer(testQueue);
            producer.send(msg);

            MessageConsumer consumer = session.createConsumer(testQueue);
            msg = consumer.receive();

            assertNull(msg.getJMSReplyTo());

        } finally {

            connection.close();
        }

    }
}
